<?php  
/*
Plugin Name: Look_like_gbo2 
Version:  2.6.A
Plugin URI: http://phpwebgallery.net/ext/extension_view.php?eid=251
Author: GBo 
Author URI: http://www.photos.bouteyron.fr/
Description:  Display thumbnail under button. Add navigation on picture look like GBo Gallery 
Add a border around  picture ......
	2.4.A Beta1 Compliance Piwigo 2.4 + jquery
	2.4.B beta 2 Compliance with Theme Stripped and plugin Piwishak  
	2.4.C First version for official Piwigo 2.4
	2.4.D Compliance with Theme Simple + fix bug on option
	2.4.F Improvement on frame management first size
		  Frame available on SlideShow.	
	2.4.G Compliance with plugin RV MAP & EARTH
-- 05-05-2013	
	2.5.A Fix bug  back to default values after  deactivates / reactivates actions 
	2.5.B Fix bug  back to default values after  deactivates / reactivates actions (with API)
	2.5.C Fix bug  notice with $lang
-- 30-12-2013   
		2.6.A Compliance Piwigo 2.6	and automatic size
 */
if (!defined('PHPWG_ROOT_PATH')) die('Hacking attempt!');

global $conf; 
define ('LLGBO_INFO_VERSION','2.6.A');
if (!defined('LLGBO_PATH'))
{define('LLGBO_PATH', PHPWG_PLUGINS_PATH.basename(dirname(__FILE__)). '/');}
	 
 $conf['LLGBO_SETTINGS'] =  explode("," , $conf['LLGBO']);
 $conf['LLGBO_TOOLTIP'] = explode(",",$conf['LLGBOTOOLTIP']);
 $conf['LLGBO_FRAME'] = explode (",",$conf['LLGBOFRAME']); 
 $conf['LLGBO_HEADER'] = explode (",",$conf['LLGBOHEADER']); 
	
 load_language('plugin.lang', LLGBO_PATH);
/******************************************************************/
/*				 Set the administration panel of the plugin */
/******************************************************************/
  function plugin_admin_menu($menu)
 /******************************************************************/
  {    array_push($menu,
        array(
          'NAME' => 'Look_like_GBo',
          'URL' => get_admin_plugin_menu_link(dirname(__FILE__).'/admin/llgbo_admin.php') ));
    return $menu;  }

/******************************************************************/
/*       ALWAYS      DISPLAY      METADATA */
/******************************************************************/
function llgbo_BeginPicture()
/******************************************************************/
{global $conf,$template;
If ($conf['LLGBO_SETTINGS'] [2]  == 'true' )  // exif under bt
	{$_GET['metadata'] = 'O';}
	
If ($conf['LLGBO_SETTINGS'][10]  == 'true' )  //always display metadata
	{if ( pwg_get_session_var('show_metadata') == null )
		{  pwg_set_session_var('show_metadata', 1 );
		 }}
}// --------------- end begin picture 

/******************************************************************/
//      MANAGE     BEGIN          H E A D E R 
/******************************************************************/
function llgbo_beginheader()
/******************************************************************/
{ global $page,$conf;
	If ($conf['LLGBO_SETTINGS'][2]  == 'true' ) // reset nofollow, noindex
	{ unset ($page['meta_robots']);}
}
/******************************************************************/
//      MANAGE               H E A D E R 
/******************************************************************/
function llgbo_endHeader()
/******************************************************************/
{global $template,$conf;
$page_name = script_basename();
include_once(LLGBO_PATH.'include/manage_header.php');
}  // --------------- end header 


/******************************************************************/
//* IMPROVE FUNCTIONNALITIES --> PICTURE.TPL
/******************************************************************/
function  llgbo_EndPicture()
/******************************************************************/
{ global $template,$conf,$page,$lang,$PictSizeWH;
$infofile = $template->get_template_vars('INFO_FILE');
$current = $template->get_template_vars('current');
 
//----------------------------------------------------	 
/*       HTML End  frame   on Picture.tpl       */
//----------------------------------------------------	
		
If (($conf['LLGBO_SETTINGS'] [0] == 'true')    //Frame
     and ($conf['LLGBO_RENDERCONTENT'] == 'true') )	// $content ok for update
	{ 	$target = 'picture';
	    if ($page['slideshow'] and $conf['light_slideshow'])
		{ $target = 'slideshow';}
		$template->set_prefilter($target, 'LLGBO_prefilter_Picture_Frame');
 

// selected picture Size	
 if (!isset($PictSizeWH)) { //$PictSizeWH is not already defined by auto_size 	
	$PictSizeWH  =  $current['selected_derivative']->get_size();}

		$frame_width  = $PictSizeWH[0];
		$frame_height = $PictSizeWH[1];

		$lastbrdpx = 0;
		$frame_begin ='';
		for ($x = 1   ;$x < 32  ; $x =$x +2)
		{ 	if ((isset($conf['LLGBO_FRAME'][$x+1])) and  ($conf['LLGBO_FRAME'][$x+1] > 0))	// boder value > 0	
			  { $bordpx= $conf['LLGBO_FRAME'][$x+1]; 
				$frame_width = $frame_width + ( 2* $lastbrdpx);				 
				$frame_height = $frame_height + ( 2* $lastbrdpx); 
			    $bordcolor = $conf['LLGBO_FRAME'][$x];
			    $frame_begin = '<div   id="llgboframe'.$x.'" class="llgbo" style="border:'.$bordpx.'px solid '.$bordcolor.'">'."\n".$frame_begin;
				$lastbrdpx = $bordpx;}
		}
		$frame_width = $frame_width + ( 2* $lastbrdpx);				 
		$frame_height = $frame_height + ( 2* $lastbrdpx); 
		$frame_size = 'style="border:0 ;width:'.$frame_width.'px; height:'.$frame_height.'px;"';
		$template->append('llgbo', array(
			 'FRAME_SIZE' => $frame_size,
			 'FRAME_BEGIN' => $frame_begin), true); 
	If (($conf['LLGBO_SETTINGS'] [5]  == 'true' )  /* title on frame */ 
	and ($conf['LLGBO_SETTINGS'] [0]  == 'true' ) )// frame
		 {  $template->append('llgbo', array(
				 'TITLE_FRAME_COLOR' => $conf['LLGBO_FRAME'][0],
				 'TITLE_FRAME' => $current['name'] ), true);
			$template->assign('SHOW_PICTURE_NAME_ON_TITLE' , false); 
			}			
	} //--------------- end frame
	
	
// ---- Metadata ----------	
$pictExt = substr($infofile,-3);
if (!in_array ( $pictExt,$conf['picture_ext']))
	{$lang['Show file metadata'] =  'No Metadata';}
	else
	{
	if ($conf['show_exif'] 	== true) // No exif ?
	{$meta = "";
	$u_metadata = $template->get_template_vars('U_METADATA');
 	$swt = "";
	 If ($conf['LLGBO_SETTINGS'] [2]  == 'true' )  // exif under bt
		{  $metadata = $template->get_template_vars('metadata');
		if (is_array($metadata)) 
		  {  if (isset($metadata[0]) and is_array($metadata[0]))
				{foreach($metadata[0] as $cle =>$tableau)
					{ if(is_array($tableau))
					 {   foreach($tableau as $cle=>$valeur)
						{   $swt= $swt.$cle.' : '.$valeur.'||';
							$meta = 1;} }	}
					if  ( pwg_get_session_var('show_metadata') == 1 )
					{  	$lang['Show file metadata'] =  'EXIF Metadata';
						 if (isset($metadata[0] ['TITLE'])) // advanced meta
						{$lang['Show file metadata']	= $metadata [0] ['TITLE'];}
						if ($meta  != 1 ) {$lang['Show file metadata'] =  'No Metadata';}
					}
					$template->assign( 'U_METADATA', $u_metadata.'" title="'.$lang['Show file metadata']."||".$swt);
					unset( $metadata[0]); 
					 $template->Clear_assign('metadata');// hide original metadata	
					 $template->assign('metadata',$metadata);} //  original metadata item > 0	
		  }
		  else
		  {if  ( pwg_get_session_var('show_metadata') == 1 )
		  {$lang['Show file metadata'] =  'No Metadata';
		   $template->assign( 'U_METADATA', $u_metadata.'" title="'.$lang['Show file metadata']);}
		   }
		} 
	  }
	}
	// --------------------------------------
	// Add llgbo requirement to ELEMENT_CONTENT
	// --------------------------------------
	$template->set_filenames( array('llgbo_content'=> dirname(__FILE__).'/template/llgbo_content.tpl') );
	$template->concat('picture', $template->parse('llgbo_content', true));
} 



/******************************************************************
			------   MANAGE PICTURE PAGE                --------------     
 ******************************************************************/
/******************************************************************/
function llgbo_RenderContent($content,$element_info)
/******************************************************************/
{global $template,$conf,$user,$lang,$themeconf,$PictSizeWH;	
$template->assign('LLGBO_PATH',LLGBO_PATH);
include_once(LLGBO_PATH.'/css/sweettitles.css.php');
//-----------------------------------------------------------------
// -----------  add CSS tooltip in footer --------------------
//-----------------------------------------------------------------
 If (($conf['LLGBO_SETTINGS'][1]  == 'true' ) /*  tooltip  */  
 or  ($conf['LLGBO_SETTINGS'] [2]  == 'true' )  /* exif under bt */ )    
	{	$template->append('footer_elements',$sweetcss);
	$template->append('llgbo', array( 'TOOLTIP' => 'ok' ), true);}
	
/*	 If ($conf['LLGBO_SETTINGS'] [3]  == 'true' )    switch free 	{}  */
$conf['LLGBO_RENDERCONTENT']   = 'false';
$PictSizeWH =null;
//-----------------------------------------------------------------
// AN OTHER PLUGIN IS WORKING -> GO BACK
//-----------------------------------------------------------------
	 if ( !empty($content) )   {
	 
		 // 2.6 paticular case automatic size management
		 $autosize_in_place = $template->get_template_vars('is_automatic_size');
		 $autosize_running = $template->get_template_vars('automatic_size');
		 $current = $template->get_template_vars('current');
		if (isset($autosize_in_place))  
		{ 		 if (isset( $autosize_running)) 
		        	{ $PictSizeWH  =  $current['selected_derivative']->get_size();}
			}	
			 else
				{ return $content;}
} 

//-----------------------------------------------------------------
// frame and navigation on picture  are only available on picture extension	
//-----------------------------------------------------------------
$pictExt = substr($element_info['file'],-3);
if (!in_array ( $pictExt,$conf['picture_ext']))	{return $content; }
$conf['LLGBO_RENDERCONTENT']  = 'true';	// $content ok for update
 include_once(LLGBO_PATH.'include/manage_picture_content.php');
	 // 2.6 paticular case automatic size management
	if ((isset($autosize_in_place))  and  (isset( $autosize_running)) )
					{	return $template->parse( 'default_content', true);}
	 
} //end --> llgbo_RenderContent


/******************************************************************/
function LLGBO_prefilter_Content_Frame($content, $smarty)
/******************************************************************/
{  
// --------------------------------------
// add  End frame  picture_content TPL
// --------------------------------------
  global $themeconf;
  $search = '{foreach from=$current.unique_derivatives';
  $replacement = '{$llgbo.FRAME_END}'
  ."</div> <!-- end GBO frame -->"
  .$search;
 if (( strpos(strtoupper($themeconf['name']) , 'STRIPPED') === 0) ) 
	{$search = 'class="hideTabs">';
  $replacement =  $search
  .'{$llgbo.FRAME_END}'
  ."</div>";}
   if (( strpos(strtoupper($themeconf['name']) , 'PWGCARBON_DFT') === 0) ) 
	{$search = '{if $DISPLAY_NAV_THUMB}';
		$replacement =   '{$llgbo.FRAME_END}'
  ."</div>"."</div> <!-- end GBO frame -->"
  .$search;}
 
  $content = str_replace($search, $replacement, $content); 
  return $content;
}


/******************************************************************/
function LLGBO_prefilter_Picture_Frame($content, $smarty)
/******************************************************************/
{  
// ------------------------------------
//  add begin frame on picture TPL
// --------------------------------------
 $search = '<div id="theImage">';
 $replacement = $search."\n".'{if isset($llgbo.TITLE_FRAME)}'."\n".'<span  id="llgboh2" style ="background:transparent;z-index:3;color:{$llgbo.TITLE_FRAME_COLOR}">{$llgbo.TITLE_FRAME}</span>';
 $replacement = $replacement."\n".'{/if}'."\n".'<div   id="llgbo0" class="llgbo" {$llgbo.FRAME_SIZE}>'."\n".'{$llgbo.FRAME_BEGIN}';

// ------------------------
  return  str_replace($search, $replacement, $content);

}
/******************************************************************/
//    trigger  intercepter    
/******************************************************************/                             
add_event_handler('loc_begin_page_header', 'llgbo_beginheader');
add_event_handler('loc_end_page_header', 'llgbo_endHeader');
Add_event_handler( 'loc_begin_picture','llgbo_BeginPicture');
Add_event_handler( 'loc_end_picture', 'llgbo_EndPicture');
add_event_handler('render_element_content', 'llgbo_RenderContent',  EVENT_HANDLER_PRIORITY_NEUTRAL-1, 20  );
add_event_handler('get_admin_plugin_menu_links',  'plugin_admin_menu' );
?>